function hideBar() {}

function loadPreAssets() {
    preAssetLib = new Utils.AssetLoader(curLang, [{
        id: "langSelect",
        file: "images/langSelect.jpg"
    }], ctx, canvas.width, canvas.height, !1), preAssetLib.onReady(initLangSelect)
}

function initLangSelect() {
    var a = preAssetLib.getData("langSelect");
    ctx.drawImage(a.img, canvas.width / 2 - a.img.width / 2, canvas.height / 2 - a.img.height / 2);
    for (var b = 140, c = 0; c < aLangs.length; c++) {
        var d = canvas.width / 2 - b * aLangs.length / 2 + c * b,
            e = canvas.height / 2 - b / 2;
        userInput.addHitArea("langSelect", butEventHandler, {
            lang: aLangs[c]
        }, {
            type: "rect",
            aRect: [d, e, d + b, e + 140]
        })
    }
}

function butEventHandler(a, b) {
    switch (console.log(a), a) {
        case "langSelect":
            console.log(b.lang), curLang = b.lang, ctx.clearRect(0, 0, canvas.width, canvas.height), userInput.removeHitArea("langSelect"), loadAssets()
    }
}

function loadAssets() {
    assetLib = new Utils.AssetLoader(curLang, [{
        id: "heroSheet",
        file: "images/" + curLang + "/hero_100x100.png",
        oData: {
            oAnims: {
                flying: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18],
                dashing: [19, 20, 21, 22]
            },
            columns: 6,
            spriteWidth: 100,
            spriteHeight: 100
        }
    }, {
        id: "enemySheet1",
        file: "images/" + curLang + "/enemy1_62x55.png",
        oData: {
            oAnims: {
                flying: [0, 1, 2, 3, 4, 5, 6, 7, 8],
                falling: [9]
            },
            columns: 5,
            spriteWidth: 62,
            spriteHeight: 55
        }
    }, {
        id: "enemySheet2",
        file: "images/" + curLang + "/enemy2_90x90.png",
        oData: {
            oAnims: {
                flying: [0, 1, 2, 3, 4, 5, 6, 7, 8],
                falling: [9]
            },
            columns: 5,
            spriteWidth: 90,
            spriteHeight: 90
        }
    }, {
        type: "image",
        id: "enemySheet3",
        file: "images/" + curLang + "/enemy3_65x72.png",
        oData: {
            oAnims: {
                flying: [0, 1, 2, 3, 4, 5, 6, 7, 8],
                falling: [9]
            },
            columns: 5,
            spriteWidth: 65,
            spriteHeight: 72
        }
    }, {
        id: "enemySheet4",
        file: "images/" + curLang + "/enemy4_55x55.png",
        oData: {
            oAnims: {
                flying: [0, 1, 2, 3, 4],
                falling: [5]
            },
            columns: 5,
            spriteWidth: 55,
            spriteHeight: 55
        }
    }, {
        id: "trailSheet",
        file: "images/" + curLang + "/trail_54x36.png",
        oData: {
            oAnims: {
                flying: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]
            },
            columns: 5,
            spriteWidth: 54,
            spriteHeight: 36
        }
    }, {
        id: "background",
        file: "images/" + curLang + "/background.jpg"
    }, {
        id: "rotateDeviceMessage",
        file: "images/" + curLang + "/rotateDeviceMessage.jpg"
    }, {
        id: "gemSheet",
        file: "images/" + curLang + "/gem_100x100.png",
        oData: {
            oAnims: {
                exploding: [4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
            },
            columns: 5,
            spriteWidth: 100,
            spriteHeight: 100
        }
    }, {
        id: "numberSheet",
        file: "images/" + curLang + "/numbers_20x25.png",
        oData: {
            columns: 5,
            spriteWidth: 20,
            spriteHeight: 25
        }
    }, {
        id: "letterSheet",
        file: "images/" + curLang + "/letters_145x145.png",
        oData: {
            oAnims: {
                exploding: [4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
            },
            columns: 5,
            spriteWidth: 145,
            spriteHeight: 145
        }
    }, {
        id: "hud",
        file: "images/" + curLang + "/hud.png"
    }, {
        id: "muteBut",
        file: "images/" + curLang + "/mute_31x31.png",
        oData: {
            columns: 2,
            spriteWidth: 31,
            spriteHeight: 31
        }
    }, {
        id: "heart",
        file: "images/" + curLang + "/heart.png"
    }, {
        id: "titleScreen",
        file: "images/" + curLang + "/title.jpg"
    }, {
        id: "helpScreen",
        file: "images/" + curLang + "/help.jpg"
    }, {
        id: "playBut",
        file: "images/" + curLang + "/play_but.png"
    }, {
        id: "endScreen",
        file: "images/" + curLang + "/end.jpg"
    }, {
        id: "splash",
        file: "images/" + curLang + "/splash.jpg"
    }, {
        id: "againBut",
        file: "images/" + curLang + "/again_but.png"
    }], ctx, canvas.width, canvas.height), assetLib.onReady(showSplash)
}

function mouseEvent(a) {
    if (a) {
        var d = Math.round((mouseState.posX - canvasX) * canvasScaleX),
            e = Math.round((mouseState.posY - canvasY) * canvasScaleY);
        switch (gameState) {
            case "splash":
                
                break;
            case "start":
                d > 110 && 350 > d && e > 230 && 310 > e && (gameState = "help", screens.setRenderFunc("help"), playSound("click")), d > 356 && 480 > d && e > 230 && 310 > e && window.open("http://www.myrealgames.com/mobile-games/?utm_source=DragonDash&utm_medium=html5_moregames");
                break;
            case "help":
                if (d > 110 && 350 > d && e > 230 && 310 > e) return gameInit(), playSound("click"), void 0;
                break;
            case "end":
          scorepost('https://' + window.location.hostname + '/?autocom=arcade&do=savescore', {
            gname : 'DragonDash_Origon',
            gscore: score
        });

                break;
            case "game":
                d > 442 && 480 > d && e > 0 && 39 > e ? togglePause() : d > 405 && 442 > d && e > 0 && 39 > e && toggleMute()
        }
    }
}

function showSplash() {
    gameState = "splash", resizeCanvas(), splash = new Elements.Splash(assetLib.getData("splash"), canvas.width, canvas.height), previousTime = (new Date).getTime(), updateSplashScreenEvent()
 
	}

function updateSplashScreenEvent() {
    if (0 == pauseState && "game" != gameState) {
        var a = (new Date).getTime(),
            b = (a - previousTime) / 1e3;
        if (previousTime = a, splashTimer += b, splashTimer > 2.5) return gameState = "start", init(), void 0;
        b > .5 && (b = 0), splash.render(ctx, b), requestAnimFrame(updateSplashScreenEvent)
    }
}

function init() {
    gameState = "start", hero = new Elements.Hero(assetLib.getData("heroSheet"), canvas.height, heroHit), hero.x = 150, hero.y = canvas.height / 4, trail = new Elements.Trail(assetLib.getData("trailSheet")), trail.x = 150, trail.y = hero.y, trail.reset(), hud = new Elements.Hud(assetLib.getData("hud"), assetLib.getData("numberSheet"), assetLib.getData("letterSheet"), assetLib.getData("heart")), screens = new Elements.Screens(assetLib.getData("titleScreen"), assetLib.getData("helpScreen"), assetLib.getData("endScreen"), assetLib.getData("playBut"), assetLib.getData("againBut"), assetLib.getData("numberSheet"), canvas.width, canvas.height), screens.setRenderFunc("start"), previousTime = (new Date).getTime(), updateStartScreenEvent()
}

function heroHit() {
    0 == dashSpeed && (hero.hit(), energy--, hud.updateHearts(energy), playSound("hitGround"), 0 >= energy && hero.killed())
}

function gameInit() {
    allowSound && !muted && music.play(), gameState = "game", score = 0, energy = 3, overSpeed = 0, enemyReleaseFreq = 2, gemReleaseInc = 0, enemyReleaseInc = 0, diffInc = 0, dashSpeed = 0, letterReleaseInc = 0, curLetter = 1, hero.reset(), trail.y = hero.y, trail.reset(), hud.reset(), background = new Elements.Background(assetLib.getData("background"), canvas.width, canvas.height), previousTime = (new Date).getTime(), updateGameEvent()
}

function updateStartScreenEvent() {
    if (0 == pauseState && "game" != gameState) {
        var a = (new Date).getTime(),
            b = (a - previousTime) / 1e3;
        previousTime = a, b > .5 && (b = 0), screens.render(ctx, b), requestAnimFrame(updateStartScreenEvent)
    }
}

function updateGameEvent() {
    if (0 == pauseState) {
        if (++inc >= incFluc) {
            var a = (new Date).getTime(),
                b = (a - previousTime) / 1e3;
            if (previousTime = a, b > .5 && (b = 0), enemyReleaseInc += b, enemyReleaseInc > enemyReleaseFreq && (addEnemy(), enemyReleaseInc = 0), gemReleaseInc += b, gemReleaseInc > gemReleaseFreq && (addGemBlock(), gemReleaseInc = 0), letterReleaseInc += b, letterReleaseInc > letterReleaseFreq && (addLetter(), letterReleaseInc = 0), diffInc += b, timeToDiffMax > diffInc && (enemyReleaseFreq = 2 - (2 - enemyReleaseFreqMin) / timeToDiffMax * diffInc, overSpeed = overSpeedMax / timeToDiffMax * diffInc), updateScene(b), hero.removeMe) return endGame(), void 0;
            checkCollisions(), renderScene(), inc = 0
        }
        renderMuteBut(), requestAnimFrame(updateGameEvent)
    }
}

function renderMuteBut() {
    if (allowSound) {
        var a = assetLib.getData("muteBut"),
            b = 0;
        muted && (b = 1);
        var c = b * a.oData.spriteWidth % a.img.width,
            d = Math.floor(b / (a.img.width / a.oData.spriteWidth)) * a.oData.spriteHeight;
        ctx.drawImage(a.img, c, d, a.oData.spriteWidth, a.oData.spriteHeight, 410, 5, a.oData.spriteWidth, a.oData.spriteHeight)
    }
}

function addGemBlock() {
    var a = Math.floor(4 * Math.random()),
        b = 30;
    switch (curGemBlockNum++, a) {
        case 0:
            for (var c = Math.ceil(4 * Math.random()) + 1, d = 6 - c, e = Math.random() * (canvas.height - 100 - c * b) + 50, f = 0; d > f; f++)
                for (var g = 0; c > g; g++) addGemPos(canvas.width + 100 + f * b, e + g * b);
            break;
        case 1:
            for (var h = Math.ceil(8 * Math.random()), e = Math.random() * (canvas.height - 100 - h * b) + 50, f = 0; h > f; f++) addGemPos(canvas.width + 100 + f * b, e + f * b);
            break;
        case 2:
            for (var h = Math.ceil(8 * Math.random()), e = Math.random() * (canvas.height - 100 - h * b) + 50, f = 0; h > f; f++) addGemPos(canvas.width + 100 + (h - f) * b, e + f * b);
            break;
        case 3:
            for (var h = Math.ceil(10 * Math.random()), e = Math.random() * (Math.PI / 2), f = 0; h > f; f++) addGemPos(canvas.width + 100 + f * b, canvas.height / 2 + 75 * Math.sin((f + e) / 2))
    }
}

function addGemPos(a, b) {
    var c = new Elements.Gem(assetLib.getData("gemSheet"), canvas.height, 120, curGemBlockNum);
    c.x = a, c.startY = b, aGems.push(c)
}

function updateScene(a) {
    background.update(a, overSpeed + dashSpeed, hero.y), hero.update(a, mouseState.isDown), trail.update(a, hero.y);
    for (var b = 0; b < aGems.length; b++) aGems[b].update(a, dashSpeed, hero.y), dashSpeed > 0 && aGems[b].x < .75 * canvas.width && aGems[b].canHit && (aGems[b].hit(), score++, hud.updateScore(score), aGems[b].blockNum != prevGemBlockNum && (playSound("gem" + Math.ceil(4 * Math.random())), prevGemBlockNum = aGems[b].blockNum)), aGems[b].removeMe && (aGems.splice(b, 1), b -= 1);
    for (var b = 0; b < aLetters.length; b++) aLetters[b].update(a, hero.y), aLetters[b].removeMe && (aLetters.splice(b, 1), b -= 1);
    for (var b = 0; b < aEnemies.length; b++) aEnemies[b].update(a, hero.y, overSpeed + dashSpeed), aEnemies[b].removeMe && (aEnemies.splice(b, 1), b -= 1)
}

function checkCollisions() {
    for (var a = 0; a < aEnemies.length; a++) checkSpriteCollision(aEnemies[a], hero) && aEnemies[a].canHit && hero.canHit && 0 == dashSpeed && (aEnemies[a].hit(), playSound("birdHit" + Math.ceil(3 * Math.random())), heroHit());
    for (var a = 0; a < aGems.length; a++) checkSpriteCollision(aGems[a], hero) && aGems[a].canHit && (aGems[a].hit(), score++, hud.updateScore(score), aGems[a].blockNum != prevGemBlockNum && (playSound("gem" + Math.ceil(4 * Math.random())), prevGemBlockNum = aGems[a].blockNum));
    for (var a = 0; a < aLetters.length; a++) checkSpriteCollision(aLetters[a], hero) && aLetters[a].canHit && (aLetters[a].hit(), hud.updateLetters(curLetter), ++curLetter >= 5 ? (dashTimer = setTimeout(dashStart, 500), playSound("dash")) : playSound("letter"))
}

function dashStart() {
    dashSpeed = 600, dashTimer = setTimeout(dashEnd, 5e3), gemReleaseFreq /= 4, trail.dashMultipler = 6, hero.setAnimType("loop", "dashing"), hero.maxSpeedY = 50, background.isDashing = !0
}

function dashEnd() {
    dashSpeed = 0, gemReleaseFreq *= 4, curLetter = 1, hud.updateLetters(0), trail.dashMultipler = 1, hero.setAnimType("loop", "flying"), hero.maxSpeedY = 175, background.isDashing = !1, hero.canHit = !1
}

function checkSpriteCollision(a, b) {
    var c = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y),
        d = (a.radius + b.radius) * (a.radius + b.radius);
    return d > c ? !0 : !1
}

function renderScene() {
    background.render(ctx);
    for (var a = 0; a < aGems.length; a++) renderSprite(aGems[a]);
    for (var a = 0; a < aLetters.length; a++) renderSprite(aLetters[a]);
    renderSprite(trail), renderSprite(hero);
    for (var a = 0; a < aEnemies.length; a++) renderSprite(aEnemies[a]);
    renderSprite(hud)
}

function renderSprite(a) {
    ctx.save(), ctx.translate(a.x, a.y), ctx.rotate(a.rotation), a.render(ctx), ctx.restore()
}

function addEnemy() {
    var b, c, d, a = Math.ceil(4 * Math.random()),
        e = 20 * Math.random();
    switch (a) {
        case 1:
            b = 10, c = 30, d = 200;
            break;
        case 2:
            b = 15, c = 15, d = 150;
            break;
        case 3:
            b = 10, c = 20, d = 200;
            break;
        case 4:
            b = 5, c = 20, d = 100
    }
    var f = new Elements.Enemy(assetLib.getData("enemySheet" + a), c, b, d, e, canvas.width, canvas.height, 120);
    f.x = canvas.width + 100 * Math.random() + 100, f.startY = Math.random() * .6 * canvas.height + .2 * canvas.height, aEnemies.push(f)
}

function addLetter() {
    if (5 > curLetter) {
        var a = new Elements.Letter(assetLib.getData("letterSheet"), curLetter - 1, canvas.height, 200);
        a.x = canvas.width + 100, a.startY = Math.random() * .6 * canvas.height + .2 * canvas.height, aLetters.push(a)
    }
}

function endGame() {
    gameState = "end", allowSound && music.stop(), highestScore = Math.max(highestScore, score), screens.updateScore(score, highestScore), screens.setRenderFunc("end"), aEnemies = new Array, aLetters = new Array, aGems = new Array, canTap = !1, previousTime = (new Date).getTime(), updateStartScreenEvent()

	}

function resizeCanvasDelay() {
    clearTimeout(resizeTimer), resizeTimer = setTimeout(function() {
        resizeCanvas()
    }, 200)
}

function resizeCanvas() {
    var a = window.innerWidth,
        b = window.innerHeight;
    a > 480 && (a -= 1, b -= 1), window.innerWidth < window.innerHeight && isMobile ? (0 == pauseState && "loading" != gameState && showDeviceRotateMessage(), canvas.style.width = a + "px", canvas.style.height = a / canvas.width * canvas.height + "px", canvasX = 0, canvasY = (b - a / canvas.width * canvas.height) / 2, canvasScaleX = canvasScaleY = canvas.width / a, div.style.marginTop = canvasY + "px", div.style.marginLeft = canvasX + "px") : isMobile ? (1 == pauseState && unPause(), canvasX = canvasY = 0, canvasScaleX = canvas.width / a, canvasScaleY = canvas.height / b, canvas.style.width = a + "px", canvas.style.height = b + "px", div.style.marginTop = "0px", div.style.marginLeft = "0px") : (1 == pauseState && unPause(), a / canvas.width < b / canvas.height ? (canvas.style.width = a + "px", canvas.style.height = a / canvas.width * canvas.height + "px", canvasX = 0, canvasY = (b - a / canvas.width * canvas.height) / 2, canvasScaleX = canvasScaleY = canvas.width / a, div.style.marginTop = canvasY + "px", div.style.marginLeft = canvasX + "px") : (canvas.style.width = b / canvas.height * canvas.width + "px", canvas.style.height = b + "px", canvasX = (a - b / canvas.height * canvas.width) / 2, canvasY = 0, canvasScaleX = canvasScaleY = canvas.height / b, div.style.marginTop = canvasY + "px", div.style.marginLeft = canvasX + "px")), userInput.setCanvas(canvasX, canvasY, canvasScaleX, canvasScaleY)
}

function playSound(a) {
    allowSound && sound.play(a)
}

function toggleMute() {
    muted = !muted, allowSound && (muted ? Howler.mute() : Howler.unmute()), renderMuteBut()
}

function togglePause() {
    0 == pauseState ? (pauseState = 2, allowSound && Howler.mute()) : (unPause(), allowSound && (muted || Howler.unmute()))
}

function showDeviceRotateMessage() {
    pauseState = 1, ctx.drawImage(assetLib.getImg("rotateDeviceMessage"), 0, 0)
}

function unPause() {
    switch (pauseState = 0, previousTime = (new Date).getTime(), gameState) {
        case "splash":
            updateSplashScreenEvent();
            break;
        case "start":
            updateStartScreenEvent();
            break;
        case "help":
            updateStartScreenEvent();
            break;
        case "game":
            updateGameEvent();
            break;
        case "end":
           
    }
}
var Utils;
! function(a) {
    var b = function() {
        function a(a, b, c, d, e, f) {
            if ("undefined" == typeof f && (f = !0), this.oAssetData = {}, this.assetsLoaded = 0, this.totalAssets = b.length, this.ctx = c, this.canvasWidth = d, this.canvasHeight = e, this.showBar = f, this.topLeftX = this.canvasWidth / 2 - 50, this.topLeftY = this.canvasHeight / 2 + 100, this.showBar) {
                var g;
                "EN" == a ? g = "Loading..." : "ES" == a ? g = "Cargando..." : "FR" == a && (g = "Chargement..."), ctx.fillStyle = "#aaaaaa", ctx.textAlign = "center", ctx.font = "12px Helvetica", ctx.fillText(g, this.canvasWidth / 2, this.topLeftY - 10), ctx.strokeStyle = "#aaaaaa", ctx.lineWidth = 2, ctx.fillStyle = "#ffffff", ctx.moveTo(this.topLeftX, this.topLeftY), ctx.lineTo(this.topLeftX + 100, this.topLeftY + 0), ctx.lineTo(this.topLeftX + 100, this.topLeftY + 10), ctx.lineTo(this.topLeftX + 0, this.topLeftY + 10), ctx.lineTo(this.topLeftX + 0, this.topLeftY + 0), ctx.stroke()
            }
            for (var h = 0; h < b.length; h++) this.loadImage(b[h])
        }
        return a.prototype.loadImage = function(a) {
            var b = this,
                c = new Image;
            c.onload = function() {
                b.oAssetData[a.id] = {}, b.oAssetData[a.id].img = c, void 0 != a.oData && (b.oAssetData[a.id].oData = a.oData), ++b.assetsLoaded, b.showBar && ctx.fillRect(b.topLeftX + 2, b.topLeftY + 2, 96 / b.totalAssets * b.assetsLoaded, 6), b.checkLoadComplete()
            }, c.src = a.file
        }, a.prototype.checkLoadComplete = function() {
            this.assetsLoaded == this.totalAssets && this.loadedCallback()
        }, a.prototype.onReady = function(a) {
            this.loadedCallback = a
        }, a.prototype.getImg = function(a) {
            return this.oAssetData[a].img
        }, a.prototype.getData = function(a) {
            return this.oAssetData[a]
        }, a
    }();
    a.AssetLoader = b
}(Utils || (Utils = {}));
var Utils;
! function(a) {
    var b = function() {
        function a(a, b, c, d) {
            this.x = 0, this.y = 0, this.rotation = 0, this.radius = 10, this.removeMe = !1, this.frameInc = 0, this.animType = "loop", this.oImgData = a, this.oAnims = this.oImgData.oData.oAnims, this.fps = b, this.radius = c, this.animId = d
        }
        return a.prototype.updateAnimation = function(a) {
            this.frameInc += this.fps * a
        }, a.prototype.resetAnim = function() {
            this.frameInc = 0
        }, a.prototype.setFrame = function(a) {
            this.fixedFrame = a
        }, a.prototype.setAnimType = function(a, b) {
            switch (this.animId = b, this.animType = a, a) {
                case "loop":
                    break;
                case "once":
                    this.resetAnim(), this.maxIdx = this.oAnims[this.animId].length - 1
            }
        }, a.prototype.render = function(a) {
            if (null != this.animId) {
                var b = this.oAnims[this.animId].length,
                    c = Math.floor(this.frameInc),
                    d = this.oAnims[this.animId][c % b],
                    e = d * this.oImgData.oData.spriteWidth % this.oImgData.img.width,
                    f = Math.floor(d / (this.oImgData.img.width / this.oImgData.oData.spriteWidth)) * this.oImgData.oData.spriteHeight;
                if ("once" == this.animType && c > this.maxIdx) {
                    this.fixedFrame = this.oAnims[this.animId][b - 1], this.animId = null, this.animEndedFunc();
                    var e = this.fixedFrame * this.oImgData.oData.spriteWidth % this.oImgData.img.width,
                        f = Math.floor(this.fixedFrame / (this.oImgData.img.width / this.oImgData.oData.spriteWidth)) * this.oImgData.oData.spriteHeight
                }
            } else var e = this.fixedFrame * this.oImgData.oData.spriteWidth % this.oImgData.img.width,
                f = Math.floor(this.fixedFrame / (this.oImgData.img.width / this.oImgData.oData.spriteWidth)) * this.oImgData.oData.spriteHeight;
            a.drawImage(this.oImgData.img, e, f, this.oImgData.oData.spriteWidth, this.oImgData.oData.spriteHeight, -this.oImgData.oData.spriteWidth / 2, -this.oImgData.oData.spriteHeight / 2, this.oImgData.oData.spriteWidth, this.oImgData.oData.spriteHeight)
        }, a
    }();
    a.AnimSprite = b
}(Utils || (Utils = {}));
var Utils;
! function(a) {
    var b = function() {
        function a(a, b) {
            this.x = 0, this.y = 0, this.rotation = 0, this.radius = 10, this.removeMe = !1, this.oImgData = a, this.radius = b
        }
        return a.prototype.setFrame = function(a) {
            this.frameNum = a
        }, a.prototype.render = function(a) {
            var b = this.frameNum * this.oImgData.oData.spriteWidth % this.oImgData.img.width,
                c = Math.floor(this.frameNum / (this.oImgData.img.width / this.oImgData.oData.spriteWidth)) * this.oImgData.oData.spriteHeight;
            a.drawImage(this.oImgData.img, b, c, this.oImgData.oData.spriteWidth, this.oImgData.oData.spriteHeight, -this.oImgData.oData.spriteWidth / 2, -this.oImgData.oData.spriteHeight / 2, this.oImgData.oData.spriteWidth, this.oImgData.oData.spriteHeight)
        }, a
    }();
    a.BasicSprite = b
}(Utils || (Utils = {}));
var Utils;
! function(a) {
    var b = function() {
        function a(a) {
            var b = this;
            this.isDown = !1, canvas = a, canvas.addEventListener("touchstart", function(a) {
                b.setState(a, a.touches[0].pageX, a.touches[0].pageY, !0)
            }, !1), canvas.addEventListener("touchend", function(a) {
                b.setState(a, a.changedTouches[0].pageX, a.changedTouches[0].pageY, !1)
            }, !1), canvas.addEventListener("mousedown", function(a) {
                b.setState(a, a.pageX, a.pageY, !0)
            }, !1), canvas.addEventListener("mouseup", function(a) {
                b.setState(a, a.pageX, a.pageY, !1)
            }, !1)
        }
        return a.prototype.onMouseEvent = function(a) {
            this.mouseEventCallback = a
        }, a.prototype.setState = function(a, b, c, d) {
            a.preventDefault(), a.stopPropagation(), this.isDown = d, this.posX = b, this.posY = c, this.mouseEventCallback(this.isDown, this.posX, this.posY)
        }, a
    }();
    a.MouseInput = b
}(Utils || (Utils = {}));
var __extends = this.__extends || function(a, b) {
        function c() {
            this.constructor = a
        }
        c.prototype = b.prototype, a.prototype = new c
    },
    Elements;
! function(a) {
    var b = function(a) {
        function b(b, c, d) {
            a.call(this, b, 20, 20, "flying"), this.incY = 0, this.accY = 0, this.maxSpeedY = 175, this.canHit = !0, this.incInvincible = 0, this.flipFlop = !0, this.incFlipFlop = 0, this.maxY = c, this.heroHitFunc = d, this.updateFunc = this.flying
        }
        return __extends(b, a), b.prototype.hit = function() {
            this.incY *= -1, this.canHit = !1
        }, b.prototype.reset = function() {
            this.canHit = !0, this.removeMe = !1, this.updateFunc = this.flying, this.x = 150, this.y = this.maxY / 4, this.incY = this.accY = 0
        }, b.prototype.update = function(b, c) {
            a.prototype.updateAnimation.call(this, b), this.updateFunc(b, c)
        }, b.prototype.flying = function(b, c) {
            a.prototype.updateAnimation.call(this, b), this.canHit || (this.incInvincible += b, this.incFlipFlop += b, this.incFlipFlop > .05 && (this.flipFlop = !this.flipFlop, this.incFlipFlop = 0), this.incInvincible > 1.5 && (this.canHit = !0, this.incInvincible = 0, this.incFlipFlop = 0)), this.accY < 500 ? this.accY += 150 * b : this.accY = 500, c ? (this.accY < 500 ? this.accY += 300 * b : this.accY = 500, this.incY -= this.accY * b) : this.incY += this.accY * b, this.incY > this.maxSpeedY ? this.incY = this.maxSpeedY : this.incY < -this.maxSpeedY && (this.incY = -this.maxSpeedY), this.rotation = this.incY / 500, this.y += this.incY * b, this.y > this.maxY ? (this.incY = 2 * -this.incY, this.y = this.maxY, this.canHit && this.heroHitFunc()) : this.y < 0 && (this.incY = -this.incY / 4, this.y = 0)
        }, b.prototype.falling = function(a) {
            this.y += this.incY * a, this.x -= 150 * a, this.incY += 500 * a, this.rotation += 5 * a, this.y > this.maxY && (this.removeMe = !0)
        }, b.prototype.render = function(b) {
            this.canHit || this.updateFunc != this.flying ? a.prototype.render.call(this, b) : this.flipFlop && a.prototype.render.call(this, b)
        }, b.prototype.killed = function() {
            this.canHit = !1, this.incY = -300, this.updateFunc = this.falling
        }, b
    }(Utils.AnimSprite);
    a.Hero = b
}(Elements || (Elements = {}));
var Elements;
! function(a) {
    var b = function(a) {
        function b(b, c, d, e, f, g, h, i) {
            a.call(this, b, c, d, "flying"), this.canHit = !0, this.offsetY = 0, this.startY = 0, this.offsetY = i, this.speedX = e, this.speedY = f, this.maxX = g, this.maxY = h, this.updateFunc = this.flying
        }
        return __extends(b, a), b.prototype.update = function(b, c, d) {
            a.prototype.updateAnimation.call(this, b), this.updateFunc(b, c, d)
        }, b.prototype.flying = function(a, b, c) {
            this.x -= (this.speedX + c) * a, b > this.y ? this.startY -= this.speedY * a : this.startY += this.speedY * a, this.x < -100 && (this.removeMe = !0), this.startY > this.maxY ? (this.speedY = -this.speedY, this.startY = this.maxY) : this.startY < 0 && (this.speedY = -this.speedY, this.startY = 0), this.y = this.startY - this.offsetY / this.maxY * b + this.offsetY / 2
        }, b.prototype.falling = function(a) {
            this.y += this.speedY * a, this.speedY += 800 * a, this.y > this.maxY && (this.removeMe = !0)
        }, b.prototype.hit = function() {
            this.canHit = !1, this.speedY = -300, this.animId = "falling", this.updateFunc = this.falling
        }, b
    }(Utils.AnimSprite);
    a.Enemy = b
}(Elements || (Elements = {}));
var Utils;
! function(a) {
    var b = function() {
        function a() {
            this.updateFreq = 10, this.updateInc = 0, this.frameAverage = 0, this.display = 1, this.log = "", this.render = function(a) {
                this.frameAverage += this.delta / this.updateFreq, ++this.updateInc >= this.updateFreq && (this.updateInc = 0, this.display = this.frameAverage, this.frameAverage = 0), a.textAlign = "left", ctx.font = "10px Helvetica", a.fillStyle = "#333333", a.beginPath(), a.rect(0, 305, 40, 15), a.closePath(), a.fill(), a.fillStyle = "#ffffff", a.fillText(Math.round(1e3 / (1e3 * this.display)) + " fps " + this.log, 5, 315)
            }
        }
        return a.prototype.update = function(a) {
            this.delta = a
        }, a
    }();
    a.FpsMeter = b
}(Utils || (Utils = {}));
var Elements;
! function(a) {
    var b = function() {
        function a(a, b, c) {
            this.scrollX = 0, this.scrollSpeedX = 500, this.jiggle = 0, this.isDashing = !1, this.y = 0, this.aSegs = new Array, this.canvasWidth = b, this.canvasHeight = c, this.aSegs = [0, 290, 310, 335, 365, 400]
        }
        return a.prototype.update = function(a, b, c) {
            this.scrollX += (this.scrollSpeedX + b) * a, this.y = 80 / this.canvasHeight * c
        }, a.prototype.render = function(a) {
            var b = this.aSegs.length - 1;
            this.jiggle = this.isDashing ? 20 * Math.random() - 10 : 0;
            for (var c = 0; b > c; c++) a.drawImage(assetLib.getImg("background"), this.scrollX * ((c + 1) / b) % this.canvasWidth, this.aSegs[c], this.canvasWidth, this.aSegs[c + 1] - this.aSegs[c], 0, this.aSegs[c] + this.jiggle - this.y, this.canvasWidth, this.aSegs[c + 1] - this.aSegs[c])
        }, a
    }();
    a.Background = b
}(Elements || (Elements = {}));
var Elements;
! function(a) {
    var b = function(a) {
        function b(b, c, d, e) {
            a.call(this, b, 15, 20, null), this.removeMe = !1, this.speedX = 250, this.speedY = 0, this.canHit = !0, this.canvasHeight = c, this.offsetY = d, this.blockNum = e, this.updateFunc = this.flying, this.setFrame(Math.floor(4 * Math.random()))
        }
        return __extends(b, a), b.prototype.update = function(a, b, c) {
            this.updateFunc(a, b, c)
        }, b.prototype.flying = function(a, b, c) {
            this.x -= (this.speedX + b) * a, this.y = this.startY - this.offsetY / this.canvasHeight * c + this.offsetY / 2, this.x < -100 && (this.removeMe = !0)
        }, b.prototype.exploding = function(b, c) {
            this.x -= (this.speedX + c) * b, this.y += this.speedY * b, a.prototype.updateAnimation.call(this, b)
        }, b.prototype.hit = function() {
            this.canHit = !1, this.speedX = 100, this.setAnimType("once", "exploding"), this.animEndedFunc = function() {
                this.removeMe = !0
            }, this.updateFunc = this.exploding
        }, b
    }(Utils.AnimSprite);
    a.Gem = b
}(Elements || (Elements = {}));
var Elements;
! function(a) {
    var b = function(a) {
        function b(b, c, d, e) {
            a.call(this, b, 20, 20, null), this.removeMe = !1, this.speedX = 500, this.speedY = 0, this.canHit = !0, this.canvasHeight = d, this.offsetY = e, this.updateFunc = this.flying, this.setFrame(c)
        }
        return __extends(b, a), b.prototype.update = function(a, b) {
            this.updateFunc(a, b)
        }, b.prototype.flying = function(a, b) {
            this.x -= this.speedX * a, this.y = this.startY - this.offsetY / this.canvasHeight * b + this.offsetY / 2, this.x < -100 && (this.removeMe = !0)
        }, b.prototype.exploding = function(b) {
            this.x -= this.speedX * b, this.y += this.speedY * b, a.prototype.updateAnimation.call(this, b)
        }, b.prototype.hit = function() {
            this.canHit = !1, this.speedX = 100, this.setAnimType("once", "exploding"), this.animEndedFunc = function() {
                this.removeMe = !0
            }, this.updateFunc = this.exploding
        }, b
    }(Utils.AnimSprite);
    a.Letter = b
}(Elements || (Elements = {}));
var Elements;
! function(a) {
    var b = function() {
        function a(a, b, c, d) {
            this.scoreTotal = 0, this.lettersTotal = 0, this.heartsTotal = 3, this.oHudImgData = a, this.oNumberImgData = b, this.oLetterImgData = c, this.oHeartImgData = d
        }
        return a.prototype.reset = function() {
            this.scoreTotal = 0, this.lettersTotal = 0, this.heartsTotal = 3
        }, a.prototype.updateScore = function(a) {
            this.scoreTotal = a
        }, a.prototype.updateLetters = function(a) {
            this.lettersTotal = a
        }, a.prototype.updateHearts = function(a) {
            this.heartsTotal = a
        }, a.prototype.render = function(a) {
            a.drawImage(this.oHudImgData.img, 0, 0);
            for (var b = 0; b < this.heartsTotal; b++) a.drawImage(this.oHeartImgData.img, 3 + 20 * b, 6);
            for (var b = 0; b < this.scoreTotal.toString().length; b++) {
                var c = this.scoreTotal.toString()[b],
                    d = c * this.oNumberImgData.oData.spriteWidth % this.oNumberImgData.img.width,
                    e = Math.floor(c / (this.oNumberImgData.img.width / this.oNumberImgData.oData.spriteWidth)) * this.oNumberImgData.oData.spriteHeight;
                a.drawImage(this.oNumberImgData.img, d, e, this.oNumberImgData.oData.spriteWidth, this.oNumberImgData.oData.spriteHeight, -this.oNumberImgData.oData.spriteWidth / 2 + 18 * b + 262, -this.oNumberImgData.oData.spriteHeight / 2 + 20, this.oNumberImgData.oData.spriteWidth, this.oNumberImgData.oData.spriteHeight)
            }
            for (var b = 0; b < this.lettersTotal; b++) {
                var c = b,
                    d = c * this.oLetterImgData.oData.spriteWidth % this.oLetterImgData.img.width,
                    e = Math.floor(c / (this.oLetterImgData.img.width / this.oLetterImgData.oData.spriteWidth)) * this.oLetterImgData.oData.spriteHeight;
                a.drawImage(this.oLetterImgData.img, d, e, this.oLetterImgData.oData.spriteWidth, this.oLetterImgData.oData.spriteHeight, -this.oLetterImgData.oData.spriteWidth / 2 + 25 * b + 105, -this.oLetterImgData.oData.spriteHeight / 2 + 21, this.oLetterImgData.oData.spriteWidth, this.oLetterImgData.oData.spriteHeight)
            }
        }, a
    }();
    a.Hud = b
}(Elements || (Elements = {}));
var Elements;
! function(a) {
    var b = function(a) {
        function b(b) {
            a.call(this, b, 30, 0, "flying"), this.aTargY = new Array, this.aCurY = new Array, this.trailIndex = 0, this.trailNum = 6, this.timeStep = .2, this.dashMultipler = 1, this.updateFunc = this.flying
        }
        return __extends(b, a), b.prototype.update = function(b, c) {
            a.prototype.updateAnimation.call(this, b), this.updateFunc(b, c)
        }, b.prototype.reset = function() {
            for (var a = 0; a <= this.trailNum; a++) this.aTargY[a] = this.aCurY[a] = this.y
        }, b.prototype.flying = function(a, b) {
            if (this.y = b, this.trailIndex += a, this.trailIndex > this.timeStep / this.dashMultipler) {
                this.trailIndex = 0;
                for (var c = this.trailNum; c > 0; c--) this.aTargY[c] = this.aCurY[c] = this.aTargY[c - 1];
                this.aTargY[0] = this.y
            }
            this.aCurY[0] = this.y;
            for (var c = 1; c <= this.trailNum; c++) this.aCurY[c] -= (this.aTargY[c] - this.aTargY[c - 1]) / Math.max(this.timeStep / this.dashMultipler / a, 1)
        }, b.prototype.render = function(a) {
            for (var b = 1; b <= this.trailNum; b++) {
                var c = this.oAnims[this.animId].length,
                    d = Math.floor(this.frameInc + 2 * b),
                    e = this.oAnims[this.animId][d % c],
                    f = e * this.oImgData.oData.spriteWidth % this.oImgData.img.width,
                    g = Math.floor(e / (this.oImgData.img.width / this.oImgData.oData.spriteWidth)) * this.oImgData.oData.spriteHeight;
                a.drawImage(this.oImgData.img, f, g, this.oImgData.oData.spriteWidth, this.oImgData.oData.spriteHeight, -this.oImgData.oData.spriteWidth - 20 * b, -this.oImgData.oData.spriteHeight / 2 - (this.y - this.aCurY[b]), this.oImgData.oData.spriteWidth, this.oImgData.oData.spriteHeight)
            }
        }, b
    }(Utils.AnimSprite);
    a.Trail = b
}(Elements || (Elements = {}));
var Elements;
! function(a) {
    var b = function() {
        function a(a, b, c, d, e, f, g, h) {
            this.incY = 0, this.score = 0, this.highestScore = 0, this.posY = 0, this.oStartScreenImgData = a, this.oHelpScreenImgData = b, this.oEndScreenImgData = c, this.oPlayButImgData = d, this.oAgainButImgData = e, this.oNumberImgData = f, this.canvasWidth = g, this.canvasHeight = h, this.posY = -this.canvasHeight
        }
        return a.prototype.setRenderFunc = function(a) {
            switch (this.posY = -this.canvasHeight, a) {
                case "start":
                    this.renderFunc = this.renderStartScreen;
                    break;
                case "help":
                    this.renderFunc = this.renderHelpScreen;
                    break;
                case "end":
                    this.renderFunc = this.renderEndScreen
					
            }
        }, a.prototype.render = function(a, b) {
            this.renderFunc(a, b)
        }, a.prototype.renderStartScreen = function(a, b) {
            this.incY += 5 * b, this.posY -= 8 * this.posY * b;
            for (var c = 40, d = 0; c > d; d++) a.drawImage(this.oStartScreenImgData.img, d * (this.canvasWidth / c), 0, this.canvasWidth / c, this.canvasHeight, d * (this.canvasWidth / c), 2 * Math.sin(this.incY + d / 5) - this.posY, this.canvasWidth / c, this.canvasHeight);
            a.drawImage(this.oPlayButImgData.img, 300 - this.oPlayButImgData.img.width / 2, 240 + 5 * Math.sin(this.incY) - this.posY)
        }, a.prototype.renderHelpScreen = function(a, b) {
            this.incY += 5 * b, this.posY -= 8 * this.posY * b, a.drawImage(this.oHelpScreenImgData.img, 0, 0 - this.posY), a.drawImage(this.oPlayButImgData.img, 0, 0, 238, this.oPlayButImgData.img.height, 300 - this.oPlayButImgData.img.width / 2, 240 + 5 * Math.sin(this.incY) - this.posY, 238, this.oPlayButImgData.img.height)
        }, a.prototype.updateScore = function(a, b) {
            this.score = a, this.highestScore = b
        }, a.prototype.renderEndScreen = function(a, b) {
            this.incY += 5 * b, this.posY -= 8 * this.posY * b;
            for (var c = 40, d = 0; c > d; d++) a.drawImage(this.oEndScreenImgData.img, d * (this.canvasWidth / c), 0, this.canvasWidth / c, this.canvasHeight, d * (this.canvasWidth / c), 2 * Math.sin(this.incY + d / 5) - this.posY, this.canvasWidth / c, this.canvasHeight);
            for (var d = 0; d < this.score.toString().length; d++) {
                var e = this.score.toString()[d],
                    f = e * this.oNumberImgData.oData.spriteWidth % this.oNumberImgData.img.width,
                    g = Math.floor(e / (this.oNumberImgData.img.width / this.oNumberImgData.oData.spriteWidth)) * this.oNumberImgData.oData.spriteHeight;
                a.drawImage(this.oNumberImgData.img, f, g, this.oNumberImgData.oData.spriteWidth, this.oNumberImgData.oData.spriteHeight, 18 * d + 128 - 18 * (this.score.toString().length / 2), -this.oNumberImgData.oData.spriteHeight / 2 + 147 - this.posY, this.oNumberImgData.oData.spriteWidth, this.oNumberImgData.oData.spriteHeight)
            }
            for (var d = 0; d < this.highestScore.toString().length; d++) {
                var e = this.highestScore.toString()[d],
                    f = e * this.oNumberImgData.oData.spriteWidth % this.oNumberImgData.img.width,
                    g = Math.floor(e / (this.oNumberImgData.img.width / this.oNumberImgData.oData.spriteWidth)) * this.oNumberImgData.oData.spriteHeight;
                a.drawImage(this.oNumberImgData.img, f, g, this.oNumberImgData.oData.spriteWidth, this.oNumberImgData.oData.spriteHeight, 18 * d + 347 - 18 * (this.highestScore.toString().length / 2), -this.oNumberImgData.oData.spriteHeight / 2 + 147 - this.posY, this.oNumberImgData.oData.spriteWidth, this.oNumberImgData.oData.spriteHeight)
            }
            a.drawImage(this.oAgainButImgData.img, 240 - this.oAgainButImgData.img.width / 2, 240 + 5 * Math.sin(this.incY) - this.posY)
        }, a
    }();
    a.Screens = b
}(Elements || (Elements = {}));
var Elements;
! function(a) {
    var b = function() {
        function a(a, b, c) {
            this.inc = 0, this.oSplashScreenImgData = a, this.canvasWidth = b, this.canvasHeight = c, this.posY = -this.canvasHeight
        }
        return a.prototype.render = function(a, b) {
            this.inc += 5 * b, this.posY -= 8 * this.posY * b, a.drawImage(this.oSplashScreenImgData.img, 0, 0 - this.posY)
        }, a
    }();
    a.Splash = b
}(Elements || (Elements = {}));
var Utils;
! function(a) {
    var b = function() {
        function a(a, b) {
            var c = this;
            this.isDown = !1, this.canvasX = 0, this.canvasY = 0, this.canvasScaleX = 1, this.canvasScaleY = 1, this.prevHitTime = 0, this.isBugBrowser = b, a.addEventListener("touchstart", function(a) {
                c.hitDown(a, a.touches[0].pageX, a.touches[0].pageY)
            }, !1), a.addEventListener("touchend", function(a) {
                c.hitUp(a, a.changedTouches[0].pageX, a.changedTouches[0].pageY)
            }, !1), a.addEventListener("mousedown", function(a) {
                c.hitDown(a, a.pageX, a.pageY)
            }, !1), a.addEventListener("mouseup", function(a) {
                c.hitUp(a, a.pageX, a.pageY)
            }, !1), this.aHitAreas = new Array
			
        }
        return a.prototype.setCanvas = function(a, b, c, d) {
            this.canvasX = a, this.canvasY = b, this.canvasScaleX = c, this.canvasScaleY = d
        }, a.prototype.hitDown = function(a, b, c) {
            var d = (new Date).getTime();
            if (!(d - this.prevHitTime < 500 && this.isBugBrowser)) {
                this.prevHitTime = d, a.preventDefault(), a.stopPropagation(), b = (b - this.canvasX) * this.canvasScaleX, c = (c - this.canvasY) * this.canvasScaleY;
                for (var e = 0; e < this.aHitAreas.length; e++)
                    if (this.aHitAreas[e].rect && b > this.aHitAreas[e].area[0] && c > this.aHitAreas[e].area[1] && b < this.aHitAreas[e].area[2] && c < this.aHitAreas[e].area[3]) {
                        this.aHitAreas[e].oData.hitX = b, this.aHitAreas[e].oData.hitY = c, this.aHitAreas[e].callback(this.aHitAreas[e].id, this.aHitAreas[e].oData);
                        break
                    }
            }
        }, a.prototype.hitUp = function(a) {
            a.preventDefault(), a.stopPropagation()
        }, a.prototype.addHitArea = function(a, b, c, d, e) {
            switch ("undefined" == typeof e && (e = !1), null == c && (c = new Object), e && this.removeHitArea(a), d.type) {
                case "image":
                    d.oImageData.isSpriteSheet ? this.aHitAreas.push({
                        id: a,
                        callback: b,
                        oData: c,
                        rect: !0,
                        area: [d.aCentrePos[0] - d.oImageData.oData.spriteHeight / 2, d.aCentrePos[1] - d.oImageData.oData.spriteHeight / 2, d.aCentrePos[0] + d.oImageData.oData.spriteWidth / 2, d.aCentrePos[1] + d.oImageData.oData.spriteHeight / 2]
                    }) : this.aHitAreas.push({
                        id: a,
                        callback: b,
                        oData: c,
                        rect: !0,
                        area: [d.aCentrePos[0] - d.oImageData.img.width / 2, d.aCentrePos[1] - d.oImageData.img.height / 2, d.aCentrePos[0] + d.oImageData.img.width / 2, d.aCentrePos[1] + d.oImageData.img.height / 2]
                    });
                    break;
                case "rect":
                    this.aHitAreas.push({
                        id: a,
                        callback: b,
                        oData: c,
                        rect: !0,
                        area: d.aRect
                    })
            }
        }, a.prototype.removeHitArea = function(a) {
            for (var b = 0; b < this.aHitAreas.length; b++) this.aHitAreas[b].id == a && (this.aHitAreas.splice(b, 1), b -= 1)
        }, a
    }();
    a.UserInput = b
}(Utils || (Utils = {}));
var aLangs = new Array("EN", "ES", "FR"),
    curLang, requestAnimFrame = function() {
        return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(a) {
            window.setTimeout(a, 1e3 / 60, (new Date).getTime())
        }
    }(),
    canvas = document.getElementById("canvas"),
    ctx = canvas.getContext("2d");
canvas.width = 480, canvas.height = 320;
var canvasX, canvasY, canvasScaleX, canvasScaleY, div = document.getElementById("viewporter"),
    previousTime, maxCanvasScale = 1.5,
    hero, trail, letter, background, aEnemies = new Array,
    aGems = new Array,
    aLetters = new Array,
    mouseState = new Utils.MouseInput(canvas);
mouseState.onMouseEvent(mouseEvent);
var assetLib, preAssetLib, pauseState = 0,
    isMobile = !1,
    enemyReleaseInc = 0,
    enemyReleaseFreq = 2,
    enemyReleaseFreqMin = .4,
    gemReleaseInc = 0,
    gemReleaseFreq = 1.5,
    hud, overSpeed = 0,
    overSpeedMax = 300,
    timeToDiffMax = 120,
    diffInc = 0,
    letterReleaseInc = 0,
    letterReleaseFreq = 4,
    curLetter = 1,
    dashTimer, dashSpeed = 0,
    energy = 3,
    screens, gameState = "loading",
    canTap = !0,
    score = 0,
    highestScore = 0,
    splash, splashTimer = 0,
    allowSound = !1,
    prevGemBlockNum = 0,
    curGemBlockNum = 0,
    sound, music, muted = !1,
    resizeTimer, inc = 0,
    incFluc = 1,
    isBugBrowser = !1,
    isIE10 = !1;
navigator.userAgent.match(/MSIE\s([\d]+)/) && (isIE10 = !0);
var deviceAgent = navigator.userAgent.toLowerCase();
(deviceAgent.match(/(iphone|ipod|ipad)/) || deviceAgent.match(/(android)/) || deviceAgent.match(/(iemobile)/) || deviceAgent.match(/iphone/i) || deviceAgent.match(/ipad/i) || deviceAgent.match(/ipod/i) || deviceAgent.match(/blackberry/i) || deviceAgent.match(/bada/i)) && (isMobile = !0, deviceAgent.match(/(android)/) && !/Chrome/.test(navigator.userAgent) && (isBugBrowser = !0));
var userInput = new Utils.UserInput(canvas, isBugBrowser);
resizeCanvas(), window.onresize = function() {
    setTimeout(function() {
        resizeCanvas()
    }, 1)
}, document.addEventListener("visibilitychange", function() {
    document.hidden ? Howler.mute() : muted || Howler.unmute()
}, !1), window.addEventListener("load", function() {
    setTimeout(function() {
        hideBar(), resizeCanvas()
    }, 0), window.addEventListener("orientationchange", function() {
        hideBar(), resizeCanvas()
    }, !1)
}), isIE10 || "undefined" == typeof window.AudioContext && "undefined" == typeof window.webkitAudioContext && -1 != navigator.userAgent.indexOf("Android") || (allowSound = !0, sound = new Howl({
    urls: ["audio/sound.ogg", "audio/sound.m4a"],
    sprite: {
        gem1: [0, 500],
        gem2: [1e3, 500],
        gem3: [2e3, 500],
        gem4: [3e3, 500],
        birdHit1: [4e3, 1e3],
        birdHit2: [5500, 600],
        birdHit3: [6500, 500],
        click: [7500, 500],
        letter: [8500, 500],
        dash: [9500, 2e3],
        hitGround: [12e3, 600]
    }
}), music = new Howl({
    urls: ["audio/music.ogg", "audio/music.m4a"],
    volume: .25,
    loop: !0
})), aLangs.length > 1 ? loadPreAssets() : (curLang = aLangs[0], loadAssets());